<!doctype html>
<html lang="en" xmlns:th="http://www.thymeleaf.org">
<head>
    <base th:href="${#request.getContextPath() + '/'}">
    <meta charset="utf-8">
    <meta name="renderer" content="webkit">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=0">
    <link rel="stylesheet" href="assets/fonts/font-awesome/css/font-awesome.css"/>
    <link rel="stylesheet" href="assets/layuiadmin/layui/css/layui.css" media="all">
    <link rel="stylesheet" href="assets/layuiadmin/style/admin.css" media="all">
    <style>
        @keyframes auto-fade {
            from {
                opacity: 1.0;
            }
            50% {
                opacity: 0.1;
            }
            to {
                opacity: 1.0;
            }
        }
        @-webkit-keyframes auto-fade {
            from {
                opacity: 1.0;
            }
            50% {
                opacity: 0.1;
            }
            to {
                opacity: 1.0;
            }
        }
        .breathing-lamp {
            animation: auto-fade 3s infinite;
            -webkit-animation: auto-fade 3s infinite;
        }
        .layui-layer-content{
            width:100%;
        }
    </style>
    <script type="text/javascript" th:inline="javascript">
        /*<![CDATA[*/
        var basePath = /*[[${#httpServletRequest.getScheme() + "://" + #httpServletRequest.getServerName() + ":" + #httpServletRequest.getServerPort() + #httpServletRequest.getContextPath()}]]*/;
        function getBaseUrl() {
            $("#basePathUrl").val(basePath);
            var a = $("#basePathUrl").val();
            return a;
        }

        /*]]>*/
    </script>
</head>
<body>
<input type="hidden" id="basePathUrl"/>
<div class="layui-fluid layui-anim layui-anim-fadein">
    <div class="layui-row">
        <div class="layui-col-md12">
            <div class="layui-card">
                <div class="layui-card-body">
                    <div class="test-table-reload-btn" style="margin-bottom: 10px;">
                        <div class="layui-inline">
                            <input type="text" id="keywords" class="layui-input search-item" placeholder="输入关键字">
                        </div>
                        <div class="layui-inline">
                            <input type="text" id="startTime" class="layui-input search-item" placeholder="开始时间" readonly>
                        </div>
                        <div class="layui-inline">
                            <input type="text" id="endTime" class="layui-input search-item" placeholder="结束时间" readonly>
                        </div>
                        <button type="button" id="search" class="layui-btn layui-btn-sm">
                            <i class="fa fa-lg fa-search"></i> 搜索
                        </button>
                    </div>
                    <table class="layui-hide" id="dataTable" lay-filter="dataTable"></table>
                    <!-- 表头按钮组 -->
                    <script type="text/html" id="headerToolBar">
                        <div class="layui-btn-group">
                            <button type="button" class="layui-btn layui-btn-sm" lay-event="saveEvent">
                                <i class="fa fa-lg fa-plus"></i> 新增
                            </button>
                            <button type="button" class="layui-btn layui-btn-normal layui-btn-sm" lay-event="updateEvent">
                                <i class="fa fa-lg fa-edit"></i> 编辑
                            </button>
                            <button type="button" class="layui-btn layui-btn-danger layui-btn-sm" lay-event="removeEvent">
                                <i class="fa fa-lg fa-trash"></i> 删除
                            </button>
                        </div>
                    </script>
                </div>
            </div>
        </div>
    </div>
</div>
<script src="assets/layuiadmin/layui/layui.js"></script>
<script>
    layui.config({
        base: 'assets/layuiadmin/'
    }).extend({
        index: 'lib/index'
    }).use(['index', 'table', 'laydate', 'common'], function() {
        var $ = layui.$;
        var $win = $(window);
        var table = layui.table;
        var admin = layui.admin;
        var layer = layui.layer;
        var laydate = layui.laydate;
        var common = layui.common;
        var resizeTimeout = null;
        var tableUrl = 'api/smartgate/listpagesmartgate';

        // 初始化表格
        function initTable() {
            table.render({
                elem: '#dataTable',
                id: 'dataTable',
                url: top.restAjax.path(tableUrl, []),
                width: admin.screen() > 1 ? '100%' : '',
                height: $win.height() - 90,
                limit: 20,
                limits: [20, 40, 60, 80, 100, 200],
                toolbar: '#headerToolBar',
                request: {
                    pageName: 'page',
                    limitName: 'rows'
                },
                cols: [
                    [
                        {type:'checkbox', fixed: 'left'},
                        {field:'rowNum', width:80, title: '序号', fixed: 'left', align:'center', templet: '<span>{{d.LAY_INDEX}}</span>'},
                        {field: 'smartGateSerialNo', width: 200, title: '设备编码', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'smartGateName', width: 220, title: '设备名称', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'smartGateIpAddress', width: 200, title: '设备IP', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'smartGatePort', width: 200, title: '设备端口', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'onlineState', width: 100, title: '在线状态', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null) {
                                    return '-';
                                }
                                if(rowData == '0') {
                                    return '<span class="breathing-lamp layui-badge">离线</span>';
                                } else if(rowData == '1') {
                                    return '<span class="breathing-lamp layui-badge layui-bg-green">在线</span>'
                                } else if(rowData == '-1') {
                                    return '<span class="breathing-lamp layui-badge layui-bg-gray">未连接</span>';
                                }
                                return rowData;
                            }
                        },
                        {field: 'lastOnlineTime', width: 180, title: '最后在线时间', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'openDoor', width: 80, title: '操作', align:'center',
                            templet: function(row) {
                                return '<button type="button" class="layui-btn layui-btn-normal layui-btn-xs" lay-event="openDoorEvent">开门</button>'
                            }
                        },
                        {field: 'generalMode', width: 160, title: '通行状态', align: 'center',
                            templet: function(row) {
                                var rowData = '<div class="layui-btn-group">';
                                if(row.generalMode == 0) {
                                    rowData += '<button type="button" class="layui-btn layui-btn-xs layui-bg-gray">人证通行</button>';
                                } else {
                                    rowData += '<button type="button" data-general-mode="0" class="layui-btn layui-btn-normal layui-btn-xs" lay-event="generalModeEvent">人证通行</button>';
                                }
                                if(row.generalMode == 1) {
                                    rowData += '<button type="button" class="layui-btn layui-btn-xs layui-bg-gray">关联身份证</button>';
                                } else {
                                    rowData += '<button type="button" data-general-mode="1" class="layui-btn layui-btn-normal layui-btn-xs" lay-event="generalModeEvent">关联身份证</button>';
                                }
                                rowData += '</div>';
                                return rowData;
                            }
                        },
                        {field: 'doorMode', width: 140, title: '开门模式', align: 'center',
                            templet: function(row) {
                                var rowData = '<div class="layui-btn-group">';
                                if(row.doorMode == 1) {
                                    rowData += '<button type="button" class="layui-btn layui-btn-xs layui-bg-gray">控制</button>';
                                } else {
                                    rowData += '<button type="button" data-door-mode="1" class="layui-btn layui-btn-normal layui-btn-xs" lay-event="doorModeEvent">控制</button>';
                                }
                                if(row.doorMode == 2) {
                                    rowData += '<button type="button" class="layui-btn layui-btn-xs layui-bg-gray">常开</button>';
                                } else {
                                    rowData += '<button type="button" data-door-mode="2" class="layui-btn layui-btn-normal layui-btn-xs" lay-event="doorModeEvent">常开</button>';
                                }
                                if(row.doorMode == 3) {
                                    rowData += '<button type="button" class="layui-btn layui-btn-xs layui-bg-gray">常闭</button>';
                                } else {
                                    rowData += '<button type="button" data-door-mode="3" class="layui-btn layui-btn-normal layui-btn-xs" lay-event="doorModeEvent">常闭</button>';
                                }
                                rowData += '</div>';
                                return rowData;
                            }
                        },
                        {field: 'trustMode', width: 240, title: '认证模式', align: 'center',
                            templet: function(row) {
                                var rowData = '<div class="layui-btn-group">';
                                var title1 = '设备提示直接由前端识别的结果控制';
                                if(row.trustMode == 1) {
                                    rowData += '<button type="button" class="layui-btn layui-btn-xs layui-bg-gray" title="'+ title1 +'">前端</button>';
                                } else {
                                    rowData += '<button type="button" data-trust-mode="1" class="layui-btn layui-btn-normal layui-btn-xs" title="'+ title1 +'" lay-event="trustModeEvent">前端</button>';
                                }
                                var title2 = '前端识别后不控制设备提示，PS：识别结果通过HTTP发送到后端平台，平台通过返回返控设备';
                                if(row.trustMode == 2) {
                                    rowData += '<button type="button" class="layui-btn layui-btn-xs layui-bg-gray" title="'+ title2 +'">托管</button>';
                                } else {
                                    rowData += '<button type="button" data-trust-mode="2" class="layui-btn layui-btn-normal layui-btn-xs" title="'+ title2 +'" lay-event="trustModeEvent">托管</button>';
                                }
                                var title3 = '设备与平台HTTP信令存在交互时走平台托管模式，HTTP信令没有回复时走前端控制模式';
                                if(row.trustMode == 3) {
                                    rowData += '<button type="button" class="layui-btn layui-btn-xs layui-bg-gray" title="'+ title3 +'">托管/前端</button>';
                                } else {
                                    rowData += '<button type="button" data-trust-mode="3" class="layui-btn layui-btn-normal layui-btn-xs" title="'+ title3 +'" lay-event="trustModeEvent">托管/前端</button>';
                                }
                                var title4 = '设备识别成功时直接控制设备提示，识别失败时不做提示，等待平台回复';
                                if(row.trustMode == 4) {
                                    rowData += '<button type="button" class="layui-btn layui-btn-xs layui-bg-gray" title="'+ title4 +'">前端/托管</button>';
                                } else {
                                    rowData += '<button type="button" data-trust-mode="4" class="layui-btn layui-btn-normal layui-btn-xs" title="'+ title4 +'" lay-event="trustModeEvent">前端/托管</button>';
                                }
                                rowData += '</div>';
                                return rowData;
                            }
                        }
                        /*
                        {field: 'smartGateSummary', width: 300, title: '设备描述', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null) {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'gmtCreate', width: 180, title: '录入时间', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null) {
                                    return '-';
                                }
                                return rowData;
                            }
                        }*/,
                        // {field:'configRecord', width:100, title: '配置闸机', fixed: 'right', align:'center',
                        //     templet: function(row) {
                        //         return '<button  lay-event="configEvent" type="button" class="layui-btn layui-btn-warm layui-btn-xs">配置闸机</button>';
                        //     }
                        // },
                    ]
                ],
                page: true,
                parseData: function(data) {
                    return {
                        'code': 0,
                        'msg': '',
                        'count': data.total,
                        'data': data.rows
                    };
                }
            });
        }
        // 重载表格
        function reloadTable(currentPage) {
            table.reload('dataTable', {
                url: top.restAjax.path(tableUrl, []),
                where: {
                    keywords: $('#keywords').val(),
                    startTime: $('#startTime').val(),
                    endTime: $('#endTime').val()
                },
                page: {
                    curr: currentPage
                },
                height: $win.height() - 90,
            });
        }
        // 初始化日期
        function initDate() {
            // 日期选择
            laydate.render({
                elem: '#startTime',
                format: 'yyyy-MM-dd'
            });
            laydate.render({
                elem: '#endTime',
                format: 'yyyy-MM-dd'
            });
        }
        // 删除
        function removeData(ids) {
            top.dialog.msg(top.dataMessage.delete, {
                time: 0,
                btn: [top.dataMessage.button.yes, top.dataMessage.button.no],
                shade: 0.3,
                yes: function (index) {
                    top.dialog.close(index);
                    var layIndex;
                    top.restAjax.delete(top.restAjax.path('api/smartgate/removesmartgate/{ids}', [ids]), {}, null, function (code, data) {
                        top.dialog.msg(top.dataMessage.deleteSuccess, {time: 1000});
                        reloadTable();
                    }, function (code, data) {
                        top.dialog.msg(data.msg);
                    }, function () {
                        layIndex = top.dialog.msg(top.dataMessage.deleting, {icon: 16, time: 0, shade: 0.3});
                    }, function () {
                        top.dialog.close(layIndex);
                    });
                }
            });
        }
        initTable();
        initDate();
        // 事件 - 页面变化
        $win.on('resize', function() {
            clearTimeout(resizeTimeout);
            resizeTimeout = setTimeout(function() {
                reloadTable();
            }, 500);
        });
        // 事件 - 搜索
        $(document).on('click', '#search', function() {
            reloadTable(1);
        });

        // 表格行中按钮事件
        table.on('tool(dataTable)', function(obj) {
            var layEvent = obj.event;
            var data = obj.data;
            if(layEvent === 'configEvent') {
                top.layer.tab({
                    area: ['80%', '80%'],
                    tab: [{
                        title: '基础设置',
                        content: "<iframe src='route/smartgate/updatesmartgateconfig1?smartGateId=" + data.smartGateId+ " ' width='100%' height='800px'  frameborder='0'></iframe>"
                    }, {
                        title: '维护设置',
                        content: "<iframe src='route/smartgate/updatesmartgateconfig2?smartGateId=" + data.smartGateId+ " ' width='100%' height='800px'  frameborder='0'></iframe>"
                    }, {
                        title: 'RTSP设置',
                        content: "<iframe src='route/smartgate/updatesmartgateconfig3?smartGateId=" + data.smartGateId+ " ' width='100%' height='800px'  frameborder='0'></iframe>"
                    }]
                });
            }
        });

        // 事件 - 增删改
        table.on('toolbar(dataTable)', function(obj) {
            var layEvent = obj.event;
            var checkStatus = table.checkStatus('dataTable');
            var checkDatas = checkStatus.data;
            if(layEvent === 'saveEvent') {
                layer.open({
                    type: 2,
                    title: false,
                    closeBtn: 0,
                    area: ['100%', '100%'],
                    shadeClose: true,
                    anim: 2,
                    content: top.restAjax.path('route/smartgate/savesmartgate', []),
                    end: function() {
                        reloadTable();
                    }
                });
            } else if(layEvent === 'updateEvent') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectEdit);
                } else if(checkDatas.length > 1) {
                    top.dialog.msg(top.dataMessage.table.selectOneEdit);
                } else {
                    layer.open({
                        type: 2,
                        title: false,
                        closeBtn: 0,
                        area: ['100%', '100%'],
                        shadeClose: true,
                        anim: 2,
                        content: top.restAjax.path('route/smartgate/updatesmartgate?smartGateId={smartGateId}', [checkDatas[0].smartGateId]),
                        end: function() {
                            reloadTable();
                        }
                    });
                }
            } else if(layEvent === 'removeEvent') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectDelete);
                } else {
                    var ids = '';
                    for(var i = 0, item; item = checkDatas[i++];) {
                        if(i > 1) {
                            ids += '_';
                        }
                        ids += item['smartgateId'];
                    }
                    removeData(ids);
                }
            }
        });
        table.on('tool(dataTable)', function(obj) {
            var data = obj.data;
            var event = obj.event;
            var self = this;
            if(event === 'openDoorEvent') {
                var loadLayerIndex;
                top.restAjax.get(top.restAjax.path('api/smartgate/getopendoorbyid/{smartGateId}', [data.smartGateId]), {}, null, function(code, data) {
                    top.dialog.msg('开门成功');
                }, function(code, data) {
                    top.dialog.msg(data.msg);
                }, function() {
                    loadLayerIndex = top.dialog.msg('正在开门...', {icon: 16, time: 0, shade: 0.3});
                }, function() {
                    top.dialog.close(loadLayerIndex);
                });
            } else if(event === 'generalModeEvent') {
                top.dialog.confirm('确认修改通行模式？', function(index) {
                    top.dialog.close(index);
                    var loadLayerIndex;
                    top.restAjax.put(top.restAjax.path('api/smartgate/updategeneralmode/{smartGateId}/{modeId}', [data.smartGateId, self.dataset.generalMode]), {}, null, function(code, data) {
                        top.dialog.msg('修改成功');
                        reloadTable();
                    }, function(code, data) {
                        top.dialog.msg(data.msg);
                    }, function() {
                        loadLayerIndex = top.dialog.msg('正在修改，请稍后...', {icon: 16, time: 0, shade: 0.3});
                    }, function() {
                        top.dialog.close(loadLayerIndex);
                    });
                });
            } else if(event === 'doorModeEvent') {
                top.dialog.confirm('确认修改开门模式？', function(index) {
                    top.dialog.close(index);
                    var loadLayerIndex;
                    top.restAjax.put(top.restAjax.path('api/smartgate/updatedoormode/{smartGateId}/{modeId}', [data.smartGateId, self.dataset.doorMode]), {}, null, function(code, data) {
                        top.dialog.msg('修改成功');
                        reloadTable();
                    }, function(code, data) {
                        top.dialog.msg(data.msg);
                    }, function() {
                        loadLayerIndex = top.dialog.msg('正在修改，请稍后...', {icon: 16, time: 0, shade: 0.3});
                    }, function() {
                        top.dialog.close(loadLayerIndex);
                    });
                });
            } else if(event === 'trustModeEvent') {
                top.dialog.confirm('确认修改认证模式？', function(index) {
                    top.dialog.close(index);
                    var loadLayerIndex;
                    top.restAjax.put(top.restAjax.path('api/smartgate/updatetrustmode/{smartGateId}/{modeId}', [data.smartGateId, self.dataset.trustMode]), {}, null, function(code, data) {
                        top.dialog.msg('修改成功');
                        reloadTable();
                    }, function(code, data) {
                        top.dialog.msg(data.msg);
                    }, function() {
                        loadLayerIndex = top.dialog.msg('正在修改，请稍后...', {icon: 16, time: 0, shade: 0.3});
                    }, function() {
                        top.dialog.close(loadLayerIndex);
                    });
                });
            }
        })
    });
</script>
</body>
</html>